require 'spec_helper'
require 'date'

module RightsizingFrameworkTest
  describe 'RightsizingFramework GetRecommendations' do
    include_context 'request metadata'

   # test sorting
    it 'Validate the recommendation for s3' do
      wrap_request do
        variables = {
          "requestInput": {
            "assetType": "AWS_S3",
            "efficiencyTarget": "crn:0:rightsizing/AWS_S3_EfficiencyTarget:system",
            "evaluationDuration": "LAST_4_WEEKS",
            "filterOptions": {},
            "returnAllInstances": false
          }
        }
        graphql url(service: service),
                format_request(
                  :rightsizingRecommendations,
                  service: service
                ),
                variables,
                apitest_headers(with_auth: true, auth_service: auth_service),
                service: service
        expect_success_graphql
        expect_json_types 'data.rightsizingRecommendations',
                          edges: :array,
                          totalCount: :int
      end
    end

    # test sum of all and compare with summary
    it 'S3  Validate group by and filter with group applied is returning 1 edge', monitoring: true do
      args_get_recommendations = {
      assetType: "AWS_S3",
      efficiencyTarget: "crn:0:rightsizing/AWS_S3_EfficiencyTarget:system",
      evaluationDuration: "LAST_4_WEEKS",
      processingFlagsMap: [
        {
          "key": "latencyMatch",
          "value": "true"
        }
      ],
      filterOptions: {
        perspectives: [
          {
            perspectiveId: "29",
            groupIds: [
              "260"
            ]
          }
        ]
      },
      "returnAllInstances": false,
      "groupingCriteria": {
        "type": "PERSPECTIVE",
        "value": 29
      }
    }
      response_recommendations_call = rightsizing_recommendations_aggregation(args_get_recommendations)
      expect(response_recommendations_call[:edges].length() > 1)
  end
  end
  end